#! /usr/bin/sh
# Script to run the program, generate its coverage information
# and move it to a directory
# Make directory to save the output
GAME=${1?Error:Game number tag not provided}
# Start fresh
cp -r zork Temporary/Zork$GAME
cd Temporary/Zork$GAME
make -s
# Populate some commands from the game
zorkCommands=(
  "east" "west" "north" "south" "up" "down"
  "inventory" "diagnose" "take all" "drop all"
  "kill troll with sword" "kill thief with knife"
  "open mailbox" "read leaflet" "drop leaflet"
  "read news" "drop news" "put bird nest in case"
  "move leaves" "open grating" "open egg"
  "open window" "enter" "take painting"
  "turn on lamp" "move rug" "open trap door"
  "drop egg" "put painting in case" "open sack"
  "jump")
# Calculate the size of zorkCommands
commandSize=${#zorkCommands[@]}
# Loop through and inset a random command at each step
for STEP in {1..500}; do
  # Get the index of the zorkCommands
  commandIndex=$(($RANDOM % $commandSize))
  # Append into testInput
  echo ${zorkCommands[$commandIndex]} >> testInput
  # Run the game with the input and save the game text
  ./zork < testInput &> ZorkOut.gameOut
  # Generate the coverage information
  fd -d 1 -e gcda -X gcov > /dev/null
  # Make directory to save the output
  mkdir -p /home/COMS665A/ZorkData/CoverageAuto/Game$GAME/Step$STEP
  # echo Moving to CoverageAuto/Game$GAME/Step$STEP
  cp testInput /home/COMS665A/ZorkData/CoverageAuto/Game$GAME/Step$STEP/input
  fd -d 1 -e gcda -e gcov -e gameOut -X mv {} /home/COMS665A/ZorkData/CoverageAuto/Game$GAME/Step$STEP
done
# Remove the temporary folder
rm -rf /home/COMS665A/Temporary/Zork$GAME
